Module Module1
    Sub text()
        Console.Clear()
        Console.WriteLine("Эта программа проверяет правильность")
        Console.WriteLine("расположения круглых скобок в выражении")
    End Sub
    Sub Main()
        text()
        Do
            Dim lineLeft As String = Console.ReadLine() : Dim lineRight As String = lineLeft
            Dim left() As Integer : Dim right() As Integer : Dim int1 As Integer : Dim int2 As Integer
            Do Until lineLeft.IndexOf("(") = -1
                If int1 = 0 Then
                    left(int1) = lineLeft.IndexOf("(")
                Else
                    left(int1) = lineLeft.IndexOf("(") + 1 + left(int1 - 1)
                End If
                lineLeft = lineLeft.Substring(lineLeft.IndexOf("("))
                int1 += 1
            Loop
            Do Until lineRight.IndexOf("(") = -1
                If int2 = 0 Then
                    right(int2) = lineRight.IndexOf("(")
                Else
                    right(int2) = lineRight.IndexOf("(") + 1 + right(int2 - 1)
                End If
                lineRight = lineRight.Substring(lineRight.IndexOf("("))
                int2 += 1
            Loop
            If int1 <> int2 Then
                Console.WriteLine("Неравное количество скобок")
                Console.ReadLine()
                text()
            ElseIf (int1 = 0 And int2 = 0) Then
                Console.WriteLine("В выражении нет скобок")
                Console.ReadLine()
                text()
            ElseIf (int1 = 0 Or int2 = 0) And (int1 <> 0 Or int2 <> 0) Then
                Console.WriteLine("Неравное количество скобок")
                Console.ReadLine()
                text()
            Else
                For i As Integer = 0 To int1
                    If left(i) < right(i) Then
                    Else
                        Console.WriteLine("Скобки расположены неправильно")
                        Console.ReadLine()
                        text()
                    End If
                Next i
                Console.WriteLine("Выражение корректно")
                Console.ReadLine()
                text()
            End If
        Loop
    End Sub

End Module
